﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		D.K（あるふぁ～秘密基地）										*/
/*	製作開始	2008/05/22														*/
/*	MAIL		dk@red.interq.or.jp												*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2008/05/22	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;
private import map;
private import fmfloader;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count = 0;		// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int game_score = 0;				//スコア
	int hi_score = 0;				//ハイスコア
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int menu_input = 0;				//敵を倒したときのWAITカウンタ

	enum MOTION{
		IDLE = 0,
		UP,
		DOWN,
		LEFT,
		RIGTH,
	};
	MOTION motion[2] = MOTION.IDLE;
	int anime[2] = 0;
	int anime_int[2] = 0;
	int anime_intdef[2] = 0;
	int anime_max[2] = 0;

	enum SEQ{
		LOOK = 0,
		INPUT,
	};
	SEQ seq = SEQ.LOOK;
	
//	int stage = 0;
	int nexttime = 0;
	int nextcount = 0;
	int anser[4];
	int intputanser[4];
	int nextpoint = 0;

	Keypad keypad;					// キーボード/ゲームパッド取得用
	
	//エフェクト用構造体
	struct EFFECT_DATA
	{
		int exist;	//存在
		int type;	//透明度
		int timer;	//生存時間
		float pos_x;//位置
		float pos_y;//位置
		int r;	//
		int g;	//
		int b;	//
		int alpha;	//透明度
		float dir;	//方向
		float speed;//速度
		float zoom_x;	//
		float zoom_y;	//
	};
	const int EFFECT_MAX = 128;
	EFFECT_DATA effect[EFFECT_MAX];

	const int map_w = 51;
	const int map_h = 51;
	int map[map_w * map_h];
	int map2[map_w * map_h];

	int player_x = 1;
	int player_y = 1;
	int player_dir = 2;

	int goal_count = 0;
	int goal_x = map_w -2;
	int goal_y = ( map_h / 2 ) -2;

	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("maptip","resource/image/maptip.bmp" , [0,255,0]);
		Hell_loadTexture("bg","resource/image/bg.bmp" , [0,255,0]);
		Hell_loadTexture("msg","resource/image/msg.bmp" , [0,255,0]);
		Hell_loadTexture("effect","resource/image/effect_ball.bmp" , [0,255,0]);
		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);

		Hell_loadWAV("get",         "resource/sound/fanfare.wav");
		Hell_loadWAV("don",         "resource/sound/punck_kick.wav");

//		loadFMF("resource/map/map.fmf");
//		map1 = new Map();
//		map1.init( this, layer1 );

		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         999999);
			savedata.write();
		}
		hi_score = savedata.getint("HI_SCORE");

		game_time_count = 0;		//ゲーム終了までの残り時間

Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;

		Hell_stopBgm( 1000 );

		int x;
		int y;
		for ( x = 0; x < map_w; x++ )
		{
			for ( y = 0; y < map_h; y++ )
			{
				map2[x + ( y * map_w )] = 0;
				
				int val = 0;
				map[x + ( y * map_w )] = 0;
				if( x == 0 )
				{
					val = 1;
				}
				if( x == ( map_w - 1 ) )
				{
					val = 1;
				}
				if( y == 0 )
				{
					val = 1;
				}
				if( y == ( map_h - 1 ) )
				{
					val = 1;
				}
				if ( ( ( x % 2 ) == 0 ) && ( ( y % 2 ) == 0 ) )
				{
					val = 1;
				}
				map[x + ( y * map_w )] = val;
			}
		}
		
		for ( x = 2; x < map_w; x++ )
		{
			if ( x == ( map_w -1 ))
			{
				continue;
			}
			for ( y = 2; y < map_h; y++ )
			{
				if ( y == ( map_h -1 ))
				{
					continue;
				}
				if ( ( ( x % 2 ) == 0 ) && ( ( y % 2 ) == 0 ) )
				{
					int dir = Hell_randInt(0, 4);
					if( y != 2 )
					{
						dir = Hell_randInt(0, 3);
					}
					int nx;
					int ny;
					switch( dir )
					{
					case 0:
						nx = 1;
						ny = 0;
						break;
					case 1:
						nx = -1;
						ny = 0;
						break;
					case 2:
						nx = 0;
						ny = 1;
						break;
					case 3:
						nx = 0;
						ny = -1;
						break;
					default:
						break;
					}
					if( map[( x + nx ) + ( ( y + ny ) * map_w )] == 0 )
					{
						map[( x + nx ) + ( ( y + ny ) * map_w )] = 1;
					}
				}
			}
		}
		map2[player_x + ( player_y * map_w )] = 1;

	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		stage_start_count++;
		if ( stage_start_count == ( 60 * 3 ) )
		{
			Hell_playBgm( "resource/sound/bgm.ogg", -1, 0 );
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		if (stage_start_count < (60 * 4))
		{
			Hell_drawTexture("msg"
				, 0
				, 0
				, 0
				, 0
				, getScreenWidth( ) , getScreenHeight( )
				, 1.0 , 1.0 );
		}
		int mx = 260;
		if ( stage_start_count < ( 60 * 1 ) )
		{
			Hell_drawFont(" 3 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( stage_start_count < ( 60 * 2 ) )
		{
			Hell_drawFont(" 2 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( stage_start_count < ( 60 * 3 ) )
		{
			Hell_drawFont(" 1 " , mx, 180 , 4 , 255,255,255);
		}
		else if ( ( stage_start_count >= ( 60 * 3 ) ) && (stage_start_count < (60 * 4)))
		{
			Hell_drawFont("GO!" , mx, 180 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if( keypad.isPushEnter(true) )
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);
//		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( hi_score ) , 400, 30 , 4 , 255,255,255);

		Hell_drawFont( "RESULTS" , 260, 220 , 2 , 255,255,255);

		min = ( game_score / 60 ) / 60;
		sec = ( game_score / 60 ) % 60;
		msec = game_score % 60;
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );

//		str = std.string.format( "%d", game_score );
//		Hell_drawFont( "TIME" ,    210, 300 , 2 , 255,255,255);
		Hell_drawFont( str , 260, 250 , 4 , 255,255,255);

/*
		if ( hi_score >= game_score )
		{
			Hell_drawFont( "NEW RECORD !",170, 390 , 4 , 255,255,255);
		}
*/
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PURESS Z OR 1 BUTTON TO EXIT" , 100, 300 , 2 , 255,255,255);
		}
		else
		{
			Hell_drawFont(" OWARI !" , 200, 320 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			effect_move( );
			system_move( );
			SeneStart_move( );
//			map1.move( );

			break;
		case SCENE.CLEAR:
			//クリア
			effect_move( );
//			mob_move( );
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
//			map1.draw( );
			system_draw( );
			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
//			map1.draw( );
			system_draw( );
			effect_draw( );
			SeneStart_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
//			map1.draw( );
			system_draw( );
			effect_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
//			map1.draw( );
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
//			map1.draw( );
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	void setseq( SEQ req)
	{
		switch( req )
		{
		case SEQ.LOOK:
			nexttime = 60 - ( stage * 2 );
			if (nexttime < 5)
			{
				nexttime = 5;
			}
			nextcount = nexttime;
			nextpoint = 0;
			{
				int i;
				for ( i = 0; i < 4; i++ )
				{
					anser[i] = Hell_randInt(0, 4);
				}
			}
			break;
		case SEQ.INPUT:
			nextpoint = 0;
			break;
		default:
			break;
		}
		seq = req;
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{


	if ( keypad.isPushUp( )) 
	{
		int x = player_x;
		int y = player_y;
		int nx;
		int ny;
		switch( player_dir )
		{
		case 0:
			nx = 0;
			ny = -1;
			break;
		case 1:
			nx = -1;
			ny = 0;
			break;
		case 2:
			nx = 0;
			ny = 1;
			break;
		case 3:
			nx = 1;
			ny = 0;
			break;
		default:
			break;
		}
		if( map[( x + nx ) + ( ( y + ny ) * map_w )] == 0 )
		{
			player_x += nx;
			player_y += ny;
			map2[player_x + ( player_y * map_w )] = 1;
		}
		else
		{
			Hell_playWAV( "don" );
		}
	}
	if ( keypad.isPushDown( )) 
	{
		player_dir += 2;
		if( player_dir > 3 )
		{
			player_dir -= 4;
		}
	}
	if(keypad.isPushLeft())
	{
		player_dir++;
		if( player_dir > 3 )
		{
			player_dir = 0;
		}
	}
	if ( keypad.isPushRight( ))
	{
		player_dir--;
		if( player_dir < 0 )
		{
			player_dir = 3;
		}
	}

	//残り時間のカウント
		game_time_count++;

		if ( goal_count < 5 )
		{
			if ( ( player_x == goal_x ) && ( player_y == goal_y ) )
			{
				Hell_playWAV( "get" );
				switch( goal_count )
				{
				case 0:
					goal_x = 1;
					goal_y = map_h - 2;
					break;
				case 1:
					goal_x = map_w - 2;
					goal_y = 1;
					break;
				case 2:
					goal_x = 1;
					goal_y = ( map_h / 2 ) - 2;
					break;
				case 3:
					goal_x = map_w - 2;
					goal_y = map_h - 2;
					break;
				default:
					goal_x = map_w - 2;
					goal_y = map_h - 2;
					break;
				}
				goal_count++;
			}
		}
		if( goal_count == 5 )
		{
			
			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
			game_score = game_time_count;
			if ( hi_score > game_score )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score);
				savedata.write();
			}

			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{

		int sx = 50;
		int sy = 50;
		int size = 4;
		int sizeh = size / 2;
		int x;
		int y;
		for ( x = 0; x < map_w; x++ )
		{
			for ( y = 0; y < map_h; y++ )
			{
				if ( map[x + ( y * map_w )] != 0 )
				{
					int x1 = sx + ( size * x ) - sizeh;
					int y1 = sy + ( size * y ) - sizeh;
					if ( iSceneStatus == SCENE.CLEAR )
					{
						Hell_drawRect(x1, y1, size, size, 0, 0, 255, 255, 255, 255);
					}
				}
				if ( map2[x + ( y * map_w )] != 0 )
				{
					int x1 = sx + ( size * x ) - sizeh;
					int y1 = sy + ( size * y ) - sizeh;
					Hell_drawRect(x1, y1, size, size, 0, 0, 128, 128, 255, 255);

				}
			}
		}
		
		{
			int x1 = sx + ( size * goal_x );
			int y1 = sy + ( size * goal_y );
			Hell_drawCircle( x1, y1, sizeh, 0, 255, 0, 0, 255);
		}
		{
			int x1 = sx + ( size * player_x );
			int y1 = sy + ( size * player_y );
//			Hell_drawCircle( x1, y1, sizeh, 0, 0, 255, 0, 255);
			float rot = player_dir * 90;
			Hell_drawTriangle(x1, y1, size, rot, 0, 0, 255, 0, 255);
			


		}

		sx = 300;
		sy = 50;
		{
			//枠
			int haba = 200;
			int x1 = sx;
			int y1 = sy;
			int x2;
			int y2;
			Hell_drawRect(x1, y1, haba, haba, 2, 0, 255, 255, 255, 255);

			int wari = 8;

			x = player_x;
			y = player_y;
			int j = 0;
			int i;
			bool lw = false;
			bool rw = false;
			bool cw = false;
			for ( i= player_dir; i < player_dir + 4; i++ )
			{
				int nx;
				int ny;
				switch( i % 4 )
				{
				case 0:
					nx = 0;
					ny = -1;
					break;
				case 1:
					nx = -1;
					ny = 0;
					break;
				case 2:
					nx = 0;
					ny = 1;
					break;
				case 3:
					nx = 1;
					ny = 0;
					break;
				default:
					break;
				}
				if( map[( x + nx ) + ( ( y + ny ) * map_w )] != 0 )
				{
					switch ( j )
					{
					case 0:
						//正面の壁
						{
							int haba1 = haba/wari;
							x1 = sx + haba1;
							y1 = sy + haba1;
							x2 = sx + haba1;
							y2 = sy + haba - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba - haba1;
							y1 = sy + haba1;
							x2 = sx + haba - haba1;
							y2 = sy + haba - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba1;
							y1 = sy + haba1;
							x2 = sx + haba - haba1;
							y2 = sy + haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba1;
							y1 = sy + haba - haba1;
							x2 = sx + haba - haba1;
							y2 = sy + haba - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);
							cw = true;
						}
						break;
					case 1:
						//左の壁
						{
							int haba1 = haba/wari;
							x1 = sx;
							y1 = sy;
							x2 = sx + haba1;
							y2 = sy + haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx;
							y1 = sy + haba;
							x2 = sx + haba1;
							y2 = y1 - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba1;
							y1 = sy + haba1;
							x2 = sx + haba1;
							y2 = sy + haba - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);
							lw = true;
						}
						break;
					case 2:
						break;
					case 3:
						//右の壁
						{
							int haba1 = haba/wari;
							x1 = sx + haba;
							y1 = sy;
							x2 = sx + haba - haba1;
							y2 = sy + haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba;
							y1 = sy + haba;
							x2 = x1 - haba1;
							y2 = y1 - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba - haba1;
							y1 = sy + haba1;
							x2 = sx + haba - haba1;
							y2 = sy + haba - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);
							rw = true;
						}
						break;
					default:
						break;
					}
				}
				//ゴール
				if( j == 0 )
				{
					if( ( ( x + nx ) == goal_x ) && ( ( y + ny ) == goal_y ) )
					{
						x1 = sx + haba / 2;
						y1 = sy + haba / 2;
						Hell_drawCircle( x1, y1, 50, 0, 255, 0, 0, 255);
					}
				}
				j++;
				
			}
			j = 0;
			for ( i= player_dir; i < player_dir + 4; i++ )
			{
				int nx;
				int ny;
				switch( i % 4 )
				{
				case 0:
					nx = 1;
					ny = -1;
					break;
				case 1:
					nx = -1;
					ny = -1;
					break;
				case 2:
					nx = -1;
					ny = 1;
					break;
				case 3:
					nx = 1;
					ny = 1;
					break;
				default:
					break;
				}
				if( map[( x + nx ) + ( ( y + ny ) * map_w )] != 0 )
				{
					switch ( j )
					{
					case 0:
						//右奥の壁
						if( rw == false )
						{
							int haba1 = haba/wari;
							x1 = sx + haba - haba1;
							y1 = sy + haba1;
							x2 = x1 + haba1;
							y2 = y1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba - haba1;
							y1 = sy + haba - haba1;
							x2 = x1 + haba1;
							y2 = y1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba - haba1;
							y1 = sy + haba1;
							x2 = x1;
							y2 = sy + haba - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);
						}
						if( cw == false )
						{
							int haba1 = haba/wari;
							x1 = sx + haba - haba1;
							y1 = sy + haba1;
							x2 = x1 - haba1;
							y2 = y1 + haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba - haba1;
							y1 = sy + haba - haba1;
							x2 = x1 - haba1;
							y2 = y1 - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba - haba1 - haba1;
							y1 = sy + haba1 + haba1;
							x2 = x1;
							y2 = sy + haba - haba1 - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);
						}
						break;
					case 1:
						//左奥の壁
						if( lw == false )
						{
							int haba1 = haba/wari;
							x1 = sx;
							y1 = sy + haba1;
							x2 = x1 + haba1;
							y2 = y1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx;
							y1 = sy + haba - haba1;
							x2 = x1 + haba1;
							y2 = y1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba1;
							y1 = sy + haba1;
							x2 = sx + haba1;
							y2 = sy + haba - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);
						}
						if( cw == false )
						{
							int haba1 = haba/wari;
							x1 = sx + haba1;
							y1 = sy + haba1;
							x2 = x1 + haba1;
							y2 = y1 + haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba1;
							y1 = sy + haba - haba1;
							x2 = x1 + haba1;
							y2 = y1 - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);

							x1 = sx + haba1 + haba1;
							y1 = sy + haba1 + haba1;
							x2 = x1;
							y2 = sy + haba - haba1 - haba1;
							Hell_drawLine(x1, y1, x2, y2, 1, 255, 255, 255, 255);
						}
						break;
					default:
						break;
					}
				}
				j++;
			}
		}




		int min;
		int sec;
		int msec;

		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		
		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		msec = game_time_count % 60;
		
		if ( iSceneStatus != SCENE.CLEAR )
		{
			str = std.string.format( "TIME %2d:%02d:%02d", min, sec, msec );
		}

//		str = std.string.format( "%dm", player_x );
		
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawFont( str , 200, 3 , 3 , r,g,b);
/*
		Hell_drawFont( "SCORE" , 10, 10 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( game_score ) , 10, 30 , 2 , 255,255,255);
		Hell_drawFont( "LEVEL" , 10, 50 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( stage ) , 10, 70 , 2 , 255,255,255);
*/
/*
		min = ( hi_score / 60 ) / 60;
		sec = ( hi_score / 60 ) % 60;
		msec = hi_score % 60;

		Hell_drawFont( "HI SCORE" , 300, 10 , 2 , 255,255,255);
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );
		Hell_drawFont( str , 300, 30 , 4 , 255,255,255);
*/	
	}
	
	//-----------------------------------------------------------------------------
	//	ポーズの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	
	//-----------------------------------------------------------------------------
	//	FMFファイルの読み込み
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
/*
	void loadFMF(char[] filepath)
	{
		scope fmf = new FMFLoader(filepath);
		layer1 = fmf.getLayer(0); // 地形
		Hell_write(layer1.width);
		Hell_write(layer1.height);
		Hell_write(layer1.chip_width);
		Hell_write(layer1.chip_height);
	}
*/
	//-----------------------------------------------------------------------------
	//	エフェクトの作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void create_effect( int type, float x, float y, float dir, float speed )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist == 0 )
			{
				effect[i].exist = 1;	//存在
				effect[i].type = type;	//
				effect[i].timer = 0;	//生存時間
				effect[i].pos_x = x;	//位置
				effect[i].pos_y = y;	//位置
				effect[i].alpha = 255;	//透明度
				effect[i].dir = dir;	//
				effect[i].speed = speed;	//
				
				//タイプによってパラメータを分けるといいかも
				effect[i].r = Hell_randInt(0, 255);	//色
				effect[i].g = Hell_randInt(0, 255);	//色
				effect[i].b = Hell_randInt(0, 255);	//色
				effect[i].zoom_x = 0.2;	//拡大率
				effect[i].zoom_y = 0.2;	//拡大率
				break;
			}
		}
	}
	//エフェクトの表示
	void effect_draw( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
/*
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTextureEx("effect"
					, effect[i].pos_x
					, effect[i].pos_y
					, 0
					, 0
					, 128, 128
					, effect[i].zoom_x , effect[i].zoom_y
					, 0
					,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
*/
				if ( effect[i].type == 0 )
				{
					Hell_drawFont("GOOD!" , cast(int)effect[i].pos_x, cast(int)effect[i].pos_y, 3 , 255,255,255);
				}
				else
				{
					Hell_drawFont("MISS" , cast(int)effect[i].pos_x, cast(int)effect[i].pos_y, 3 , 255,255,255);
				}
			}
		}
		Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
	}
	//エフェクトの移動
	void effect_move( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				effect[i].timer++;	//生存時間

				float vx = Hell_cosEx( effect[i].dir ) * effect[i].speed;
				float vy = Hell_sinEx( effect[i].dir ) * effect[i].speed;
				effect[i].pos_x += vx;	//位置
				effect[i].pos_y += vy;	//位置

				//タイプによって動きを分けるといいかも
				if (effect[i].timer > 20 )
				{
					effect[i].exist = 0;
				}
			}
		}
	}
}


